
/**

Author: Kevin Loughran

**/

(function(window)
{	
	// terminal script for local hosting:
	// python -m SimpleHTTPServer 7000

	//--------------------------- CONSTRUCTOR:
	
	var Title = function()
	{
		
	}
	
	//--------------------------- STATS:

	
	//--------------------------- CONSTANTS:

	
	//--------------------------- GLOBAL VARIABLES:
	
	var titleMenu;
	var storyMenu;
	var titleLoop;
	var mode = 'story';
	var isEnding = false;
	
	//--------------------------- PUBLIC METHODS:
	
	Title.init = function()
	{
		var div;
		var img;
		var txt;
		var hit;
		
		// get container
		cont = document.getElementById("container");
				
		// add title menu
		titleMenu = document.createElement("div");
		titleMenu.style.position = 'absolute';
		titleMenu.style.width = "600px";
		titleMenu.style.height = "400px";
		titleMenu.style.background = 'url("img/title/bg.png")';
		TweenMax.to( titleMenu, 0, {y:0, alpha:1});
		cont.appendChild( titleMenu );
		
		// add flash
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.background = '#fff';
		TweenMax.to( div, 0, {x:0, y:0, alpha:0});
		titleMenu.appendChild( div );
		titleMenu.white = div;
		
		// add logo
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = "504px";
		div.style.height = "226px";
		div.style.background = 'url("img/title/logo.png")';
		TweenMax.to( div, 0, {x:46, y:20-400, alpha:1});
		
		titleMenu.appendChild( div );
		titleMenu.logo = div;
		titleMenu.logo.endY = 20;
		
		// add start
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = "152px";
		div.style.height = "60px";
		div.style.background = 'url("img/title/start.png")';
		div.style.cursor = 'pointer';
		TweenMax.to( div, 0, {x:220, y:330+400, alpha:1});
		titleMenu.appendChild( div );
		$( div ).bind( "click", onStartClick);
		
		titleMenu.appendChild( div );
		titleMenu.start = div;
		titleMenu.start.endY = 330;
		
		// add credits
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = "80px";
		div.style.height = "32px";
		div.style.background = 'url("img/title/credits.png")';
		div.style.cursor = 'pointer';
		TweenMax.to( div, 0, {x:432, y:350+400, alpha:1});
		titleMenu.appendChild( div );
		$( div ).bind( "click", onCreditsClick);
		
		titleMenu.appendChild( div );
		titleMenu.credits = div;
		titleMenu.credits.endY = 350;
		
		// add black
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.background = '#000';
		titleMenu.appendChild( div );
		titleMenu.black = div;
		
		// add credits display
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.background = 'url("img/menus/credits.png")';
		div.style.cursor = 'pointer';
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
		titleMenu.appendChild( div );
		titleMenu.creditsMenu = div;
		$( div ).bind( "click", onCreditsClose);
		
		// load audio
		titleLoop = new Audio('audio/music/mp3/title_theme.mp3');
		titleLoop.loop = true;
		titleLoop.play();
		
		titleClick = new Audio('audio/sfx/mp3/ui/button_01.mp3');
		
		// build story
		buildStory();
		
		// play animation
		if(isEnding==false)
		{
			TweenMax.delayedCall(.5, showTitle);
		}
		else
		{
			TweenMax.delayedCall(.5, showEnding);
		}
		
	}
	
	Title.setEnding = function()
	{
		isEnding = true;
	}
	
	function buildStory()
	{
		var div;
		var img;
		var txt;
		var hit;
		var i,j,k;
		var newX, newY;
		
		// add story menu
		storyMenu = document.createElement("div");
		storyMenu.style.position = 'absolute';
		storyMenu.style.width = "600px";
		storyMenu.style.height = "400px";
		storyMenu.style.background = 'none';
		TweenMax.to( storyMenu, 0, {y:0, autoAlpha:0});
		cont.appendChild( storyMenu );
		
		// add panels
		div = document.createElement("div");
		div.style.position = 'absolute';
		storyMenu.appendChild( div );
		storyMenu.panels = div;
		TweenMax.to( div, 0, {x:600});
		
		// add pages
		for(i=1; i<=3; i++)
		{
			img = document.createElement("div");
			img.style.position = 'absolute';
			img.style.width = '600px';
			img.style.height = '400px';
			img.style.background = "url('img/story/page0" + i + ".png')";
			TweenMax.to( img, 0, {x:600*(i-1)});
			storyMenu.panels.appendChild( img );
		}
		
		// add button
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.width = '77px';
		div.style.height = '33px';
		div.style.cursor = 'pointer';
		storyMenu.appendChild( div );
		TweenMax.to(div, 0, {x:520, y:364, autoAlpha:0, scaleX:0, scaleY:0});
		storyMenu.cta = div;
		$( div ).bind( "click", onNextClick);
		
		img = document.createElement("div");
		img.style.position = 'absolute';
		img.style.width = '77px';
		img.style.height = '33px';
		img.style.background = 'url("img/story/next.png")';
		div.appendChild( img );
		div.next = img;
		
		img = document.createElement("div");
		img.style.position = 'absolute';
		img.style.width = '77px';
		img.style.height = '33px';
		img.style.background = 'url("img/story/end.png")';
		div.appendChild( img );
		div.end = img;
		TweenMax.to(img, 0, {autoAlpha:0});
	}
	
	//--------------------------- EVENT METHODS:
	
	function showTitle()
	{
		TweenMax.to(titleMenu.black, 		  .3, {autoAlpha:0, ease:Quad.easeOut});
		TweenMax.to(titleMenu.logo, 		 1.0, {delay:0.3, y:titleMenu.logo.endY, ease:Back.easeOut});
		TweenMax.to(titleMenu.start,  		  .6, {delay:1.6, y:titleMenu.start.endY, ease:Back.easeOut});
		TweenMax.to(titleMenu.credits, 	  	  .6, {delay:2.0, y:titleMenu.credits.endY, ease:Back.easeOut});
	} 	
	
	function hideTitle()
	{
		//$(titleLoop).animate( {volume:0}, 500);
		
		TweenMax.to(titleMenu.white, 0, {alpha:1});
		TweenMax.to(titleMenu.white, 0.5, {delay:0.0, autoAlpha:0, ease:Quad.easeOut});
		TweenMax.to(titleMenu.black, 0.7, {delay:0.5, autoAlpha:1, ease:Quad.easeOut, onComplete:showStory});
	}
	
	function showStory()
	{
		TweenMax.to(storyMenu, 0, {autoAlpha:1});
		TweenMax.to(storyMenu.panels, 	.5, {delay:.1, x:0, ease:Quad.easeInOut});
		TweenMax.to(storyMenu.cta, 		.5, {delay:1.0, autoAlpha:1, ease:Quad.easeInOut});
		TweenMax.to(storyMenu.cta, 		.5, {delay:1.0, scaleX:1, scaleY:1, ease:Back.easeOut});
	}
	
	function showEnding()
	{
		mode = 'ending';
		TweenMax.to(storyMenu, 0, {autoAlpha:1});
		TweenMax.to(storyMenu.panels, 	 0, {delay:0, x:-1800});
		TweenMax.to(storyMenu.panels, 	.5, {delay:.1, x:-1200, ease:Quad.easeInOut});
		TweenMax.to(storyMenu.cta, 		.5, {delay:1.0, autoAlpha:1, ease:Quad.easeInOut});
		TweenMax.to(storyMenu.cta, 		.5, {delay:1.0, scaleX:1, scaleY:1, ease:Back.easeOut});
	}
	
	function moveToGame()
	{
		$(titleLoop).animate( {volume:0}, 500);
		//titleLoop.pause();
		cont.removeChild(titleMenu);
		Main.init();
	}
	
	//--------------------------- INPUT METHODS:
	
	function onStartClick(e)
	{
		titleClick.play();
		$( e.target ).unbind( "click", onStartClick);
		hideTitle();
	}
	
	function onCreditsClick(e)
	{
		console.log('show');
		TweenMax.to( titleMenu.black,		.2, {delay:0.0, autoAlpha:.7, ease:Quad.easeOut});
		TweenMax.to( titleMenu.creditsMenu, .2, {delay:0.2, autoAlpha:1});
	}
	
	function onCreditsClose(e)
	{
		console.log('hide');
		TweenMax.to( titleMenu.creditsMenu, .2, {delay:0.0, autoAlpha:0});
		TweenMax.to( titleMenu.black,		.2, {delay:0.1, autoAlpha:0, ease:Quad.easeOut});
	}
	
	function onNextClick(e)
	{
		titleClick.play();
		
		if(mode=='story')
		{
			TweenMax.to( storyMenu.cta,		.2,	{autoAlpha:0, scaleX:0, scaleY:0, ease:Quad.easeOut});
			TweenMax.to( storyMenu.panels, 	.5, {delay:0, x:-600, ease:Quad.easeInOut});
			TweenMax.to(storyMenu.cta, 		.5, {delay:1.5, autoAlpha:1, ease:Quad.easeInOut});
			TweenMax.to(storyMenu.cta, 		.5, {delay:1.5, scaleX:1, scaleY:1, ease:Back.easeOut});
			mode='togame'
		}
		else if(mode=='togame')
		{
			TweenMax.to( storyMenu.cta,		.2,	{autoAlpha:0, scaleX:0, scaleY:0, ease:Quad.easeOut});
			TweenMax.to( storyMenu,		 	.5, {delay:0, autoAlpha:0, ease:Quad.easeOut, onComplete:moveToGame});
			//mode='togame'
		}
		else if(mode=='ending')
		{
			TweenMax.to( storyMenu.cta,		.2,	{autoAlpha:0, scaleX:0, scaleY:0, ease:Quad.easeOut});
			TweenMax.to( storyMenu,		 	.5, {delay:0, autoAlpha:0, ease:Quad.easeOut, onComplete:moveToGame});
			//mode='togame'
		}
	}
	
	//--------------------------- UTILITY METHODS:
	
	function removeImg(img)
	{
		//img.destroy();
		img.destroy();
	}

	//----------------------------------------------


window.Title = Title;
}(window));